verify-conformance-requirements.sh 1.7 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556
  1. #!/usr/bin/env bash
  2. # Copyright 2019 The Kubernetes Authors.
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # This script checks conformance tests follow the requirements as
  16. # https://git.k8s.io/community/contributors/devel/sig-architecture/conformance-tests.md#conformance-test-requirements
  17. # Usage: `hack/verify-conformance-requirements.sh`.
  18. set -o errexit
  19. set -o nounset
  20. set -o pipefail
  21. KUBE_ROOT=$(dirname "${BASH_SOURCE[0]}")/..
  22. source "${KUBE_ROOT}/hack/lib/init.sh"
  23. source "${KUBE_ROOT}/hack/lib/util.sh"
  24. kube::golang::verify_go_version
  25. cd "${KUBE_ROOT}"
  26. errors=()
  27. # Check conformance tests follow the requirements as https://git.k8s.io/community/contributors/devel/sig-architecture/conformance-tests.md#conformance-test-requirements
  28. if ! failedLint=$(go run "${KUBE_ROOT}"/hack/conformance/check_conformance_test_requirements.go "${KUBE_ROOT}"/test/e2e/)
  29. then
  30. errors+=( "${failedLint}" )
  31. fi
  32. # Check to be sure all the packages that should pass lint are.
  33. if [ ${#errors[@]} -eq 0 ]; then
  34. echo 'Congratulations! All e2e test source files have been linted for conformance requirements.'
  35. else
  36. {
  37. echo "Errors from lint:"
  38. for err in "${errors[@]}"; do
  39. echo "$err"
  40. done
  41. echo
  42. echo 'Please review the above warnings.'
  43. echo
  44. } >&2
  45. exit 1
  46. fi